#File:		hanoi.s
		addiu $sp,$sp,0x03F0	#Set stack pointer for the board
main:		addiu $sp,$sp,-20		#stack frame is 32 bytes long
		sw    $ra,16($sp)		#store return address

		addi $a0,$0,7  		# largest disc = 1st arg
		addi $a1,$0,1  		#  source peg = 2nd arg
		addi $a2,$0,2  		#  destination peg = 3rd arg
		addi $a3,$0,4  		#  temp peg = 4th arg
		
		jal hanoi 			# call procedure

exit:
		ori  $a0,$0,0xF  		# set first pattern for blink to all on
		ori  $a1,$0,0xF		# set second pattern for blink to all on
		jal blink			# turn on all the lights
		lw   $ra,20($sp)		# restore ra
		addiu $sp,$sp,20		# restore stack pointer
stall:	nop  				
		j stall			# infinite loop
	
########################################
#
#  hanoi(n,src,dest,tmp)
#
########################################	
hanoi:
				#return if n = 0
	
				# adjust stack pointer 
				# save registers to stack

				# set arguments for recursive call

	jal hanoi		# recursive call



				# set arguments for call to print
	jal print



				# set arguments for second recursive call
	jal hanoi
	
return:	
				#restore registers
				#pop stack
base:	jr    $ra		#return from hanoi

###########################################
#
# print(n,src,dest) 
#     
###########################################
print:
	addiu $sp,$sp,-20		# allocate space for $ra, args
	sw	  $ra,16($sp)	# save return address
	sw	  $a2,8($sp)	# save dest peg 
	sw 	  $a1,4($sp)	# save src peg
	sw    $a0,0($sp)		# save disc
	or    $a0,$0,$0		# setup delay 
	or    $a1,$0,$0		
	jal   blink			# delay by setting LEDs to 0,0
	ori   $a0,$0,0x6		# MOVE START PATTERN PART 1
	ori   $a1,$0,0x9		# MOVE START PATTERN PART 2
	jal   blink			# display start pattern
	lw    $a0,0($sp)		# restore disc
	or	$a1,$0,$0		
	jal   blink			# call blink with the disc number
	jal   delay			
	lw	$a0,4($sp) 		# restore the source peg
	and   $a1,$0,$0		
	jal   blink			# call blink with the src peg number
	jal   delay			
	lw    $a0,8($sp)		# get the dest peg	
	and   $a1,$0,$0		
	jal   blink         	# blink the destination peg
	jal   delay			
	ori   $a0,$0,0x6		# MOVE END PATTERN PART 1
	ori   $a1,$0,0x9		# MOVE END PATTERN PART 2
	jal   blink			# show 0110, then 1001 to signify end of a move
	or    $a0,$0,$0
	or    $a1,$0,$0
	jal   blink			# extra long delay
	lw    $ra, 16($sp)	# restore return address
	addiu $sp, $sp, 20	# pop stack
	jr    $ra			# return from print

######################################################
#
# blink(a1,a2)
#	set LED to a1, wait, set LED to a2, wait, return
#
######################################################
blink:
	addiu	$sp,$sp,-20		# allocate space
	sw	$ra,16($sp)		# store return address
	sw	$a1,4($sp)		# store second pattern
	lui	$t0,0x8000		# set LED address
	sw	$a0,0($t0)		# send first arg to LED
	jal   delay			# wait
	lw    $a0,4($sp)		# restore second pattern    
	lui	$t0,0x8000		# set LED address
	sw	$a0,0($t0)		# send second arg to LED
	jal   delay			# wait
	lw	$ra, 16($sp)	# restore return address
	addiu $sp,$sp,20		# pop stack
	jr 	  $ra			# return from blink

#########################################################
#
# simple delay loop
#
#########################################################
delay:
	lui   $t1,0x0100		# set delay amount		
dloop:				
	addi $t1,$t1,-1		
	bgtz $t1,dloop
	jr 	 $ra			# no calls, so $ra is fine

